
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/mman.h>

const char* message[] =
    {"Data cache read: ",
     "Data memory read:",
     "Data PTE access: ",
     "Data write:      ",
     "Instruction cache read: ",
     "Instruction memory read:",
     "Instruction PTE access: ",
     "Collisions:             " };
 
int main (int argc , char **argv)
{
   int sum,n,i,j,k,h,h1,p,imap;
   char *dname = "/dev/mem";
   int mem [9]; 
   double d,d2;
   double dmem [10];
   int *addr;
   int *ptr;

   imap=open(dname,O_RDONLY);

   addr = NULL;

   ptr = mmap(addr,4096,PROT_READ,0,imap,0xE0005000);

   if (ptr == MAP_FAILED)
    {
     printf("Error at mmap.\n");
    }
   else
    {

     h = (int)ptr;
     printf("Address used : %8x\n",h);

     if (argc == 2)   /* Progname und ein Argument */
      {
       if (!strncmp(argv[1],"-init",5))
// do not optimize with -O2 otherwise the clear counter will be gone
        { h = *(ptr + 0x3FF); // clear counters
	  printf("Counters set to 0.\n"); }
       else
           printf("-init, unknown argument : %s\n",argv[1]);
      }
     else
      {

       for (i=0;i<=8;i++) {mem[i] = *(ptr+i+0x100); }

       for (i=0;i<8;i++)
        {
         d = mem[i];
         if (mem[i]<0) {d=d+65536.0*65536.0;}
         dmem[i] = d*16.0;
        }
// Correction memory read data - PTE accesses
       dmem[1]=dmem[1] - 2.0*(dmem[2]+dmem[6]);

       for (i=0;i<4;i++)
        {
         printf("%s %14.0f",message[i],dmem[i]);
	 printf("  %s %14.0f\n",message[i+4],dmem[i+4]);
        }

       d=(dmem[0]-dmem[1])*100.0/dmem[0];
       printf("Data hit-rate:          %6.2f %c",d,'%');
       d=(dmem[4]-dmem[5])*100.0/dmem[4];
       printf("  Instruction hit-rate:          %6.2f %c\n",d,'%');

       j=mem[8];
       d=j;
       if (j<0) {d=d+65536.0*65536.0;}
       d=d/1000000.0;
       printf("Time since last reset: %12.6f sec.\n",d);

     }
     h=munmap(ptr,4096);
     printf("munmap : %1d\n",h);
    }

   close(imap);

   return 0;

}
